.nolist
.include "m328pdef.inc" ; Define device ATmega328P
.list
;
; Soma os nmeros de 1 a NUM e salva o resultado na
; posicao SUM da memoria SRAM. As somas parciais
; sao armazenadas em um vetor a partir da posicao VECT.
; Exemplo de acesso indexado e uso de constantes .EQU e
; e uso de simbolos .DEF para nomear os registradores

;.NOLIST					; Inclui o arquivo de definicoes (com listagem desabilitada).
;.INCLUDE "m328pdef.inc"	; Comentado porque O Studio6 inclui por default conforme o device escolhido
;.LIST						; (ver menu Project->Properties->Tool Chain->General->Include File

.DEF ACC = R0				; renomeia R0
.DEF COUNT = R16			; renomeia R16
.DEF MAX = R18				; renomeia R18

.EQU NUM = 10				; numero de inteiros a somar (constante)
.EQU SUM = SRAM_START		; aloca a variavel SUM no inicio da SRAM (definido no m328pdef.inc)
.EQU VECT = SRAM_START + 1	; aloca o inicio do vetor no segundo byte da SRAM

.ORG 0
   RJMP INIT			; Primeira instrucao apos RESET eh lida em 0x0000

INIT:
   CLR ACC				; R0: somas parciais
   LDI COUNT, 1			; R16: parcelas da soma
   LDI MAX, NUM			; R18: numero de parcelas
   LDI XH, HIGH(VECT)	; R27 <- 01 (R27 definido como XH em m328pdef.inc)
   LDI XL, LOW(VECT)	; R26 <- 01 (R26 definido como XH em m328pdef.inc)
						; R27:R26 compoem o ponteiro "X" de 16 bits

LOOP:
   CP MAX, COUNT		; FLAGS ? (R18 - R16)
   BRMI END_LOOP        ; Se R18 < R16, encerra o loop
      ADD ACC, COUNT	; R0 <- R0 + R16
      INC COUNT			; R16 <- R16 + 1
      ST X+, ACC		; DATA(X) <- R0; X <- X+1
   RJMP LOOP			; retorna ao loop
END_LOOP:
   STS SUM, ACC			; DATA(0x100) <- R0

   SLEEP

